#! /bin/sh
#========================================================================
# yd2ymd converts yyyyddd to yyyymmdd
# usage yd2ymd 1998213
#
# Author: Mo Budlong <mo.budlong@sunworld.com>
#
# Source: SunWorld Online UNIX 101 columns:
#	http://www.sunworld.com/sunworldonline/swol-11-1998/swol-11-unix101.html
#	http://www.sunworld.com/swol-12-1998/swol-12-unix101.html?1201a
#
# [11-Dec-1998]
#========================================================================

# if there is no command line argument, assume one is being
# piped in and read it

if [ X$1 = X ]
then
    read dt
else
    dt=$1
fi

# break apart the year and the days

y=`expr $dt / 1000`
d=`expr $dt % 1000`

# subtract the number of days in each month starting from 1
# from the days in the date. When the day goes below 1, you
# have the current month. Add back the number of days in the
# month to get the correct day of the month
m=1
while [ `expr $d \> 0` = 1 ]
do
    md=`monthdays $y $m`
    d=`expr $d \- $md`
    m=`expr $m \+ 1`
done

d=`expr $d \+ $md`

# the loop steps one past the correct month, so back up the month
m=`expr $m \- 1`

# assemble the results into a gregorian date
grg=`expr \( $y \* 10000 \) \+ \( $m \* 100 \) \+ $d`
echo $grg
